/**
 * Please complete these missing tags
 * @see
 * @concurrency
 * @copyright
 * @rref
 */
// $Header: /teamproj/cvsroot/teamb/stylesrc/au/edu/swin/synergy/style/BTokeniser.java,v 1.3 1999/08/14 05:46:08 tp079519 Exp $

/**
 * This is a token generator
 * It recogonises tokens which make up the Java language
 * @author John Newbigin
 *
 * You create an object and read token by token
 * getToken() returns the type of token
 * getString() returns the string
 * getLineNo() returns the current line number
 *
 */

package au.edu.swin.synergy.style;


import java.lang.*;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

public class BTokeniser
{
    
    public static final int TT_ANY = - 1;
    public static final int TT_EOF = 0;
    public static final int TT_WORD = 1;
    public static final int TT_COMMENT = 2;
    public static final int TT_STRING = 3;
    public static final int TT_NEWLINE = 4;
    public static final int TT_BLOCKCOMMENT = 5;
    public static final int TT_CHAR = 6;
    public static final int TT_SYMBOL = 7;
    public static final int TT_NUMBER = 8;
    
    
    int peeked = - 1;
    private File file = null;
    private FileReader reader = null;
    private int state = 0;
    private int peekedChar = - 1;
    private String string = null;
    private int lineNo = 1;
    
    
    private static final String WHITESPACE = "\r\n \t";
    private static final String WORDCHARS = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_";
    private static final String WORDFOLLOWS = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890_";
    private static final String SPECIALCHARS = "=()[]{}.,;:+-*<>#@^%/?&|!";
    private static final String EQUALS = "=+-*<>^%&|!/";
    private static final String DOUBLESPECIAL = "&|+-";
    // <>
    private static final String DIGITCHARS = "0123456789";
    private static final String DIGITFOLLOWS = "0123456789.xabcdefABCDEFlL";
    
    private static final int EOF = - 1;
    /**
     * Please complete the missing tags for BTokeniser
     * @post
     * @pre
     * @throws
     * @returns
     * @param
     */
    
    public BTokeniser( File fFile ) throws IOException
    {
        file = fFile;
        reader = new FileReader( file );
        state = 1;
    }
    /**
     * Please complete the missing tags for getString
     * @post
     * @pre
     * @throws
     * @returns
     * @param
     */
    
    public String getString()
    {
        return string;
    }
    /**
     * Please complete the missing tags for getLineNo
     * @post
     * @pre
     * @throws
     * @returns
     * @param
     */
    
    public int getLineNo()
    {
        return lineNo;
    }
    /**
     * Please complete the missing tags for getToken
     * @post
     * @pre
     * @throws
     * @returns
     * @param
     */
    
    
    public BToken getToken()
    {
        // return values
        // 0 - error or EOF
        // 1 - word
        // 2 - single line comment
        // 3 - string
        // 4 - new line
        // 5 - start of block comment
        // 6 - inside block comment
        // 7 - end of block comment
        // 8 - char 'nnn'
        // 9 - special char
        
        string = new String();
        
        // Skip leading ws
        while( instring( PeekChar(), WHITESPACE ) >= 0 )
        {
            if( PeekChar() == 10 )
            {
                AcceptChar();
                return new BToken( TT_NEWLINE, getLineNo(), getString() );
            }
            AcceptChar();
        }
        
        
        if( instring( PeekChar(), SPECIALCHARS ) >= 0 )
        {
            int c = AcceptChar();
            cat( c );
            
            
            // there are some special cases here for 2 byte special chars
            
            if( ( instring( c, EQUALS ) >= 0 ) && ( PeekChar() == '=' ) )
            {
                cat( AcceptChar() );
            }
            
            else if( ( instring( c, DOUBLESPECIAL ) >= 0 ) && ( PeekChar() == c ) )
            {
                cat( AcceptChar() );
            }
            
            else if( ( c == '/' ) && ( PeekChar() == '/' ) )
            {
                cat( AcceptChar() );
                while( ( PeekChar() != 10 ) && ( PeekChar() != EOF ) )
                {
                    cat( AcceptChar() );
                }
                return new BToken( TT_COMMENT, getLineNo(), getString() );
            }
            else if( ( c == '/' ) && ( PeekChar() == '*' ) )
            {
                // scan till end of comment
                cat( AcceptChar() );
                while( true )
                {
                    c = AcceptChar();
                    if( ( c == '*' ) && ( PeekChar() == '/' ) )
                    {
                        cat( c );
                        cat( AcceptChar() );
                        return new BToken( TT_BLOCKCOMMENT, getLineNo(), getString() );
                    }
                    else if( c == EOF )
                    {
                        return new BToken( TT_EOF, getLineNo(), getString() );
                    }
                    cat( c );
                }
            }
            return new BToken( TT_SYMBOL, getLineNo(), getString() );
        }
        
        if( instring( PeekChar(), DIGITCHARS ) >= 0 )
        {
            cat( AcceptChar() );
            while( instring( PeekChar(), DIGITFOLLOWS ) >= 0 )
            {
                cat( AcceptChar() );
            }
            return new BToken( TT_NUMBER, getLineNo(), getString() );
        }
        
        if( instring( PeekChar(), WORDCHARS ) >= 0 )
        {
            cat( AcceptChar() );
            while( instring( PeekChar(), WORDFOLLOWS ) >= 0 )
            {
                cat( AcceptChar() );
            }
            return new BToken( TT_WORD, getLineNo(), getString() );
        }
        
        // strings
        if( PeekChar() == '"' )
        {
            cat( AcceptChar() );
            while( PeekChar() != '"' )
            {
                if( PeekChar() == EOF )
                {
                    return new BToken( TT_EOF, getLineNo(), getString() );
                }
                else if( PeekChar() == '\\' )
                {
                    // read in the escaped value...
                    cat( AcceptChar() );
                }
                ;
                cat( AcceptChar() );
            }
            cat( AcceptChar() );
            return new BToken( TT_STRING, getLineNo(), getString() );
        }
        if( PeekChar() == '\'' )
        {
            cat( AcceptChar() );
            while( PeekChar() != '\'' )
            {
                if( PeekChar() == EOF )
                {
                    return new BToken( TT_EOF, getLineNo(), getString() );
                }
                else if( PeekChar() == '\\' )
                {
                    // read in the escaped value...
                    cat( AcceptChar() );
                }
                cat( AcceptChar() );
            }
            cat( AcceptChar() );
            return new BToken( TT_CHAR, getLineNo(), getString() );
        }
        
        return new BToken( TT_EOF, getLineNo(), getString() );
    }
    /**
     * Please complete the missing tags for close
     * @param
     * @returns
     * @throws
     * @pre
     * @post
     */
    
    void close() throws IOException
    {
        reader.close();
    }
    /**
     * Please complete the missing tags for instring
     * @post
     * @pre
     * @throws
     * @returns
     * @param
     */
    
    private int instring( int c, String str )
    {
        return str.indexOf( ( char ) c );
    }
    /**
     * Please complete the missing tags for cat
     * @post
     * @pre
     * @throws
     * @returns
     * @param
     */
    
    private void cat( int c )
    {
        string = string + ( char ) c;
    }
    /**
     * Please complete the missing tags for GetChar
     * @post
     * @pre
     * @throws
     * @returns
     * @param
     */
    
    private int GetChar()
    {
        if( peeked != - 1 )
        {
            int ret = peeked;
            peeked = - 1;
            return ret;
        }
        try
        {
            // we need to put line translations in here....
            // handle missing chr 10's.....
            
            int c = reader.read();
            if( c == 13 )
            {
                //System.out.print("#13 ");
                int r = reader.read();
                if( r == 10 )
                {
                    c = r;
                }
                else
                {
                    peeked = r;
                    c = 10;
                }
                //System.out.print("missing #10! ");
            }
            if( c == 10 )
            {
                //System.out.print("#10 ");
                lineNo++;
            }
            return c;
        }
        catch( IOException e )
        {
            return EOF;
        }
    }
    /**
     * Please complete the missing tags for AcceptChar
     * @post
     * @pre
     * @throws
     * @returns
     * @param
     */
    
    private int AcceptChar()
    {
        if( peekedChar == EOF )
        {
            return GetChar();
        }
        else
        {
            int r = peekedChar;
            peekedChar = EOF;
            return r;
        }
    }
    /**
     * Please complete the missing tags for PeekChar
     * @post
     * @pre
     * @throws
     * @returns
     * @param
     */
    
    private int PeekChar()
    {
        if( peekedChar == EOF )
        {
            peekedChar = GetChar();
        }
        return peekedChar;
    }
}
